SystemOrganization addCategory: #MECCG!
SystemOrganization addCategory: 'MECCG-MTGS'!
SystemOrganization addCategory: 'MECCG-MTGS-Tests-Integration'!
SystemOrganization addCategory: 'MECCG-MTGS-Tests-Unit'!
SystemOrganization addCategory: 'MECCG-Model'!
SystemOrganization addCategory: 'MECCG-Model-Tests-Integration'!
SystemOrganization addCategory: 'MECCG-Model-Tests-Unit'!
SystemOrganization addCategory: 'MECCG-Support'!
SystemOrganization addCategory: 'MECCG-Support-Tests'!

TestCase subclass: #DrawPhaseAndActionIntegration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS-Tests-Integration'!

!DrawPhaseAndActionIntegration commentStamp: 'SergioFedi 5/22/2016 00:29' prior: 0!
This class tests the integration between a Draw Phase and the Draw Action.!

!DrawPhaseAndActionIntegration methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:16'!
test_01_ANewPhaseHas1DrawAction

	| match player phase |
	match := MTGSMatch new.
	player := MTGSPlayer named: 'Ruperto'.
	player match: match.
	phase := MTGSDrawPhase new.
	self assert: phase actions size = 2.
	self assert: phase actions last endsPhase not.
	self assert: phase actions first endsPhase.
	self assert: phase actions last phase notNil.
	self assert: phase actions last phase = phase.
! !

!DrawPhaseAndActionIntegration methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:29'!
test_02_DrawingACardRemovesItFromThePhase

	| match player phase drawAction |
	match := MTGSMatch new.
	player := MTGSPlayer named: 'Ruperto'.
	player match: match.
	phase := MTGSDrawPhase new.
	drawAction := phase actions last.
	self assert: (phase actions includes: drawAction).

	phase actions last perform.

	self assert: phase actions size = 1.
	self assert: phase actions last endsPhase.
	self assert: phase actions first endsPhase.
	self assert: (phase actions includes: drawAction) not.
! !

TestCase subclass: #EndOfTurnPhaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!EndOfTurnPhaseTest commentStamp: '<historical>' prior: 0!
An EndOfTurnPhaseTest is a test class for testing the behavior of EndOfTurnPhase!

TestCase subclass: #EndPhaseActionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!EndPhaseActionTest commentStamp: '<historical>' prior: 0!
An EndPhaseActionTest is a test class for testing the behavior of EndPhaseAction!

!EndPhaseActionTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:53'!
test_01_Creation

	| action |
	action := EndPhaseAction match: Match new.
	self assert: action endsPhase.
	self assert: action name = 'EndPhase'.! !

TestCase subclass: #MECCGBoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!MECCGBoardTest commentStamp: '<historical>' prior: 0!
A MECCGBoardTest is a test class for testing the behavior of MECCGBoard!

!MECCGBoardTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:28'!
test_01_AssignCorrectBoardToMatch

	| match |
	match := MECCGMatch new.
	match board: MECCGBoard new.
	! !

!MECCGBoardTest methodsFor: 'public' stamp: 'FedericoFigueredo 5/12/2016 08:37'!
test_02_BoardShouldHaveOneZoneForEachPlayer
	| board validator | 
	board := MECCGBoard new.
	validator := MECCGBoardValidator new.
	
	self assert: (validator isThereAZoneForEachPlayerIn: board).
	! !

!MECCGBoardTest methodsFor: 'public' stamp: 'FedericoFigueredo 5/16/2016 08:25'!
test_03_TheBoardCanHostLocations
	| board | 
	board := MECCGBoard new.
	
	self assert: false.! !

!MECCGBoardTest methodsFor: 'public' stamp: 'SergioFedi 5/14/2016 19:40'!
test_04_PlayerZoneShouldHaveValidPiles
	| board validator |
	board := MECCGBoard new.
	validator := MECCGBoardValidator new.
	self assert: (board zones allSatisfy: [ :zone | validator arePilesValidIn: zone ]).
	! !

!MECCGBoardTest methodsFor: 'public' stamp: 'SergioFedi 5/14/2016 19:40'!
test_05_PlayerHandIsValid
	| board validator |
	board := MECCGBoard new.
	validator := MECCGBoardValidator new.
	self assert: (board zones allSatisfy: [ :zone | validator isPlayerHandValidIn: zone ]).
! !

!MECCGBoardTest methodsFor: 'public' stamp: 'SergioFedi 5/10/2016 15:29'!
test_06_PlayerZoneShouldHaveSomewhereToPlayCards
	"Fede, I expect you to (define/find the definition of) this zone"

	self assert: false.
	! !

!MECCGBoardTest methodsFor: 'public' stamp: 'FedericoFigueredo 5/12/2016 08:57'!
test_xx_BoardIsValid

	self assert: false.
	! !

TestCase subclass: #MECCGBoardZoneTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!MECCGBoardZoneTest commentStamp: '<historical>' prior: 0!
A MECCGBoardZoneTest is a test class for testing the behavior of MECCGBoardZone!

!MECCGBoardZoneTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:57'!
test_01_Creation

	| zone |
	zone := MECCGBoardZone new.
	self assert: zone piles size = 4.
	self assert: zone discardPile isEmpty.
	self assert: zone marshallingPile isEmpty.
	self assert: zone outOfPlayPile isEmpty.
	self assert: zone playPile isEmpty.
	! !

TestCase subclass: #MECCGListenerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support-Tests'!

!MECCGListenerTest commentStamp: '<historical>' prior: 0!
A MECCGListenerTest is a test class for testing the behavior of MECCGListener!

!MECCGListenerTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/22/2016 02:00'!
tearDown

	| possibleZombieClasses |
	super tearDown.
	true ifTrue: [^self].
	"Tenemos que fijarnos si hay zombies despues de correr los tests"
	possibleZombieClasses := MECCGListener allSubclasses.
	possibleZombieClasses add: MECCGListener.
	possibleZombieClasses do: [ :each |
		each allInstances notEmpty ifTrue: [
			self halt.
		]
	]! !

MECCGListenerTest subclass: #MECCGLoggerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support-Tests'!

!MECCGLoggerTest commentStamp: '<historical>' prior: 0!
A MECCGLoggerTest is a test class for testing the behavior of MECCGLogger!

!MECCGLoggerTest methodsFor: 'public' stamp: 'SergioFedi 5/7/2016 14:43'!
test_01_Subscribing

	| logger |
	logger := MECCGLogger on: self.
	self assert: logger source = self.
	self deny: (self hasActionsWithReceiver: logger).
	logger logEvents: #testEvent.
	self assert: (self hasActionsWithReceiver: logger).
	logger detach.
	self deny: (self hasActionsWithReceiver: logger).
! !

!MECCGLoggerTest methodsFor: 'public' stamp: 'SergioFedi 5/7/2016 14:39'!
test_02_LogIsEmptyAtCreation

	| logger |
	logger := MECCGLogger on: self.
	self assert: (logger log isEmpty).
! !

!MECCGLoggerTest methodsFor: 'public' stamp: 'FedericoFigueredo 5/8/2016 14:02'!
test_03_EventsAreAddedToLog

	| logger |
	logger := MECCGLogger on: self.
	self assert: (logger log isEmpty).
	logger logEvents: #testEvent.
	self assert: (logger log isEmpty).
	self triggerEvent: #testEvent with: 'Test message'.
	self assert: (logger log isEmpty not).
	self assert: (logger log isSubstringOfInfiniteLoopGeneratedBy: 'Test message').
	logger detach.
	self assert: (logger log isEmpty not).
	self deny: (self hasActionsWithReceiver: logger).
! !

MECCGListenerTest subclass: #MECCGTranscriptLoggerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support-Tests'!

!MECCGTranscriptLoggerTest commentStamp: '<historical>' prior: 0!
A MECCGTranscriptLoggerTest is a test class for testing the behavior of MECCGTranscriptLogger!

!MECCGTranscriptLoggerTest methodsFor: 'public' stamp: 'SergioFedi 5/7/2016 14:44'!
test_01_Subscribing

	| logger |
	logger := MECCGTranscriptLogger on: self.
	self assert: logger source = self.
	self deny: (self hasActionsWithReceiver: logger).
	logger logEvents: #testEvent.
	self assert: (self hasActionsWithReceiver: logger).
	logger detach.
	self deny: (self hasActionsWithReceiver: logger).
! !

!MECCGTranscriptLoggerTest methodsFor: 'public' stamp: 'SergioFedi 5/7/2016 15:00'!
test_02_LogIsNilAtCreation

	| logger |
	logger := MECCGTranscriptLogger on: self.
	self assert: (logger sink isNil).
	logger logOn: Transcript.
	self assert: (logger sink notNil).
! !

MECCGListenerTest subclass: #StringOfObjectsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support-Tests'!

!StringOfObjectsTest methodsFor: 'public' stamp: 'SergioFedi 5/5/2016 07:00'!
test_01_Creation

	| stringOfObjects |
	stringOfObjects := StringOfObjects new.
	self assert: stringOfObjects size = 0.! !

!StringOfObjectsTest methodsFor: 'public' stamp: 'SergioFedi 5/5/2016 07:01'!
test_02_Add

	| stringOfObjects |
	stringOfObjects := StringOfObjects new.
	stringOfObjects add: Object new.
	self assert: stringOfObjects size = 1.! !

!StringOfObjectsTest methodsFor: 'public' stamp: 'SergioFedi 5/5/2016 07:16'!
test_03_AddAll

	| stringOfObjects |
	stringOfObjects := StringOfObjects new.
	stringOfObjects addAll: #(1 '' 3 Object).
	self assert: stringOfObjects size = 4.
	! !

!StringOfObjectsTest methodsFor: 'public' stamp: 'SergioFedi 5/5/2016 07:17'!
test_04_CreationWithAll

	| stringOfObjects |
	stringOfObjects := StringOfObjects withAll: #().
	self assert: stringOfObjects size = 0.
	stringOfObjects := StringOfObjects withAll: #(1 2 3 4 5 6).
	self assert: stringOfObjects size = 6.
	! !

!StringOfObjectsTest methodsFor: 'public' stamp: 'FedericoFigueredo 5/8/2016 13:30'!
test_05_EmptyStringIsAlwaysSubstring

	| stringOfObjects |
	stringOfObjects := StringOfObjects new.
	self assert: (stringOfObjects isSubstringOfInfiniteLoopGeneratedBy: #()).
	self assert: (stringOfObjects isSubstringOfInfiniteLoopGeneratedBy: #(1 2 3)).
	
		! !

!StringOfObjectsTest methodsFor: 'public' stamp: 'FedericoFigueredo 5/8/2016 13:34'!
test_06_ComplexCasesOfObjectsInOrder

	| stringOfObjects templateObjects |
	templateObjects := OrderedCollection withAll: #(1 2 3 4).
	stringOfObjects := StringOfObjects withAll: #(1 2 3).
	self assert: (stringOfObjects isSubstringOfInfiniteLoopGeneratedBy: templateObjects).
	stringOfObjects := StringOfObjects withAll: #(1 2 3 4 1).
	self assert: (stringOfObjects isSubstringOfInfiniteLoopGeneratedBy: templateObjects).
	stringOfObjects := StringOfObjects withAll: #(1 2 3 4 1 2 3 4 1 2).
	self assert: (stringOfObjects isSubstringOfInfiniteLoopGeneratedBy: templateObjects).
	! !

!StringOfObjectsTest methodsFor: 'public' stamp: 'SergioFedi 5/7/2016 02:31'!
test_07_SimpleCasesOfStringsOrderedAllowingZeroOrMoreInstancesOfOneElement

	| strings stringOfObjects |
	strings := OrderedCollection with: 'abc' with: 'ABC' with: '123' with: 'xyz'.
	stringOfObjects := StringOfObjects new.
	self deny: (stringOfObjects areTheseStringsOrdered: strings allowingZeroOrMoreInstancesOf: 'ABC').
	stringOfObjects := StringOfObjects withAll: (OrderedCollection with: 'abc' with: '123' with: 'xyz').
	self assert: (stringOfObjects areTheseStringsOrdered: strings allowingZeroOrMoreInstancesOf: 'ABC').
	stringOfObjects := StringOfObjects withAll: (OrderedCollection with: 'abc' with: 'ABC' with: '123' with: 'xyz').
	self assert: (stringOfObjects areTheseStringsOrdered: strings allowingZeroOrMoreInstancesOf: 'ABC').
	stringOfObjects := StringOfObjects withAll: (OrderedCollection with: 'abc' with: 'ABC' with: 'ABC' with: '123' with: 'xyz').
	self assert: (stringOfObjects areTheseStringsOrdered: strings allowingZeroOrMoreInstancesOf: 'ABC').
! !

!StringOfObjectsTest methodsFor: 'public' stamp: 'FedericoFigueredo 5/8/2016 13:44'!
test_08_ComplexCasesOfStringsOrderedAllowingZeroOrMoreInstancesOfOneElement

	| regularExpression |
	"regExpForAreTheseStringsOrdered = giveMeTheRegularExpressionToCheckWhetherTheseCharactersAreOrdered"
	regularExpression := StringOfObjects new regExpForAreTheseCharactersOrdered: 'ABCD' allowingZeroOrMoreInstancesOf: $B.
	"matchesRegex = matchesRegularExpression"
	self assert: ('ACD' matchesRegex: regularExpression).
	self assert: ('ABCD' matchesRegex: regularExpression).
	self assert: ('ABBBCD' matchesRegex: regularExpression).
	self assert: ('ACDABCDABBBCD' matchesRegex: regularExpression).
	self deny: ('' matchesRegex: regularExpression).
	self deny: ('ABD' matchesRegex: regularExpression).
	self deny: ('AD' matchesRegex: regularExpression).
	self deny: ('ABB' matchesRegex: regularExpression).! !

MECCGListenerTest subclass: #TurnsPlayedVictoryConditionTest
	instanceVariableNames: 'mockTurnsPlayed timesAmountOfTurnsPlayedWasAsked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!TurnsPlayedVictoryConditionTest commentStamp: 'SergioFedi 5/21/2016 18:03' prior: 0!
A TurnsPlayedVictoryConditionTest is a test class for testing the behavior of TurnsPlayedVictoryCondition!

!TurnsPlayedVictoryConditionTest methodsFor: 'private' stamp: 'FedericoFigueredo 5/20/2016 09:46'!
mockTurnsPlayed
	^ mockTurnsPlayed! !

!TurnsPlayedVictoryConditionTest methodsFor: 'private' stamp: 'FedericoFigueredo 5/20/2016 09:27'!
mockTurnsPlayed: anInteger 
	mockTurnsPlayed := anInteger.! !

!TurnsPlayedVictoryConditionTest methodsFor: 'private' stamp: 'FedericoFigueredo 5/20/2016 09:29'!
setUp
	super setUp.
	timesAmountOfTurnsPlayedWasAsked := 0.! !

!TurnsPlayedVictoryConditionTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 18:51'!
test_01_Creation
	
	| victoryCondition match |
	victoryCondition := TurnsPlayedVictoryCondition named: 'Turns Played'.
	self assert: victoryCondition name = 'Turns Played'.
	self assert: victoryCondition detector isNil.
	self assert: victoryCondition match isNil.
	match := Match new.
	victoryCondition match: match.
	self assert: victoryCondition match notNil.
! !

!TurnsPlayedVictoryConditionTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:11'!
test_02_ManagingTheDetector
	
	| victoryCondition match |
	match := Match new.
	victoryCondition := TurnsPlayedVictoryCondition named: 'Turns Played'.
	victoryCondition match: match.
	self deny: (match hasActionsWithReceiver: victoryCondition detector).
	victoryCondition installDetector.
	self assert: victoryCondition detector notNil.
	self assert: victoryCondition detector victoryCondition = victoryCondition.
	self assert: (match hasActionsWithReceiver: victoryCondition detector).
	victoryCondition uninstallDetector.
	self assert: victoryCondition match notNil.
	self deny: (match hasActionsWithReceiver: victoryCondition detector).
! !

!TurnsPlayedVictoryConditionTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:01'!
test_03_defaultThreshold
	
	| turnsPlayedVictoryCondition expectedDefaultValue |
	turnsPlayedVictoryCondition := TurnsPlayedVictoryCondition named: 'Turns Played'.
	expectedDefaultValue := turnsPlayedVictoryCondition defaultThreshold.
	
	"Testing a range of values since —as of 20/05/2016— we don't have a specific value in mind."
	self assert: expectedDefaultValue notNil.
	self assert: expectedDefaultValue > 120. "Based on players exhausting their decks once and never playing any cards."
	self assert: expectedDefaultValue < 600. "5x the amount of turns a ridiculous match in which nothing happens would take."
	self assert: turnsPlayedVictoryCondition turnsThreshold = expectedDefaultValue.
! !

!TurnsPlayedVictoryConditionTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:20'!
test_04_VictoryConditionDetectorUpdatesAtEndOfTurn
	
	| victoryCondition |
	victoryCondition := TurnsPlayedVictoryCondition named: 'Turns Played'.
	victoryCondition match: self. "We are mocking here!!"
	victoryCondition installDetector.
	victoryCondition detector victoryCondition: self. "We are mocking here!!"
	
	self mockTurnsPlayed: 10.
	self assert: self timesAmountOfTurnsPlayedWasAsked = 0.
	self triggerEvent: #somethingHappened with: 'End turn of player '.
	self assert: self timesAmountOfTurnsPlayedWasAsked = 1.

	victoryCondition uninstallDetector.
! !

!TurnsPlayedVictoryConditionTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:22'!
test_05_VictoryConditionDetectorFulfillsWhenThresholdIsReached
	
	| victoryCondition |
	self assert: false.
	victoryCondition := TurnsPlayedVictoryCondition named: 'Turns Played'.
	victoryCondition match: self. "We are mocking here!!"
	victoryCondition installDetector.
	victoryCondition detector victoryCondition: self. "We are mocking here!!"
	
	self mockTurnsPlayed: 10.
	self assert: self timesAmountOfTurnsPlayedWasAsked = 0.
	self triggerEvent: #somethingHappened with: 'End turn of player '.
	self assert: self timesAmountOfTurnsPlayedWasAsked = 1.

	victoryCondition uninstallDetector.
! !

!TurnsPlayedVictoryConditionTest methodsFor: 'private' stamp: 'FedericoFigueredo 5/20/2016 09:28'!
timesAmountOfTurnsPlayedWasAsked
	^ timesAmountOfTurnsPlayedWasAsked.! !

!TurnsPlayedVictoryConditionTest methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 19:18'!
turnsPlayed
	timesAmountOfTurnsPlayedWasAsked := timesAmountOfTurnsPlayedWasAsked + 1.
	^ self mockTurnsPlayed.! !

!TurnsPlayedVictoryConditionTest methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 19:16'!
turnsThreshold

	^100.! !

TestCase subclass: #MECCGMatchAndVictoryConditions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Integration'!

!MECCGMatchAndVictoryConditions commentStamp: 'SergioFedi 5/21/2016 17:58' prior: 0!
These integration tests are for the itneractions between a MECCG Match and its VictoryConditions.!

!MECCGMatchAndVictoryConditions methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:27'!
test_01_MatchHasTurnsPlayedVictoryCondition
	
	| match turnsPlayedVictoryCondition |
	match := MECCGMatch new.
	match player1: (MECCGPlayer named: 'Fede Padawan').
	match player2: (MECCGPlayer named: 'Pieter').
	match board: MECCGBoard new.
	self assert: match isReadyForSetup.
	match setup.
	turnsPlayedVictoryCondition := match victoryConditions
		detect: [ :victoryCondition | victoryCondition name = 'Turns Played']
		ifNone: [ nil ].
	self assert: turnsPlayedVictoryCondition notNil.! !

!MECCGMatchAndVictoryConditions methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:28'!
test_02_MatchHasTurnsPlayedVictoryConditionDetector
	
	| match turnsPlayedVictoryCondition |
	match := MECCGMatch new.
	match player1: (MECCGPlayer named: 'Fede Padawan').
	match player2: (MECCGPlayer named: 'Pieter').
	match board: MECCGBoard new.
	self assert: match isReadyForSetup.
	match setup.
	turnsPlayedVictoryCondition := match victoryConditions
		detect: [ :victoryCondition | victoryCondition name = 'Turns Played']
		ifNone: [ nil ].
	self assert: turnsPlayedVictoryCondition detector match = match.! !

!MECCGMatchAndVictoryConditions methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:28'!
test_03_VictoryConditionDetectorUpdatesAtEndOfTurn
	
	| match turnsPlayedVictoryCondition |
	match := MECCGMatch new.
	match player1: (MECCGPlayer named: 'Fede Padawan').
	match player2: (MECCGPlayer named: 'Pieter').
	match board: MECCGBoard new.
	self assert: match isReadyForSetup.
	match setup.
	turnsPlayedVictoryCondition := match victoryConditions
		detect: [ :victoryCondition | victoryCondition name = 'Turns Played']
		ifNone: [ nil ].
	self assert: turnsPlayedVictoryCondition turnsPlayed = 0.
	match play.
	self assert: turnsPlayedVictoryCondition turnsPlayed = 7.
! !

TestCase subclass: #MECCGMatchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!MECCGMatchTest commentStamp: '<historical>' prior: 0!
A MECCGMatchTest is a test class for testing the behavior of MECCGMatch!

!MECCGMatchTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:48'!
test_01_Creation

	| match |
	match := MECCGMatch new.
	self assert: match board notNil.
	self assert: match result isNil.
	self assert: match rules notNil.
	self assert: match victoryConditions isEmpty.
	self assert: match player1 isNil.
	self assert: match player2 isNil.
	! !

!MECCGMatchTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:51'!
test_02_SettingThePlayers

	| match |
	match := MECCGMatch new.
	match player1: (MECCGPlayer named: 'Fede Padawan').
	match player2: (MECCGPlayer named: 'Pieter').
	self assert: match player1 name = 'Fede Padawan'.
	self assert: match player2 name = 'Pieter'.
	self assert: (match players allSatisfy: [:player | player match = match]).! !

TestCase subclass: #MECCGModelUsageExamples
	instanceVariableNames: 'match logger players'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Integration'!

!MECCGModelUsageExamples commentStamp: 'SergioFedi 5/7/2016 11:33' prior: 0!
This class holds various integration and functional tests for the model.

The first test shows a typical usage and how to setup a logger that registers the different activities that take place in the match.
!

!MECCGModelUsageExamples methodsFor: 'private' stamp: 'FedericoFigueredo 5/6/2016 09:29'!
checkLogger: logger toMakeSureThePhaseOrderIsTheSameAsIn: phases 
	| logMessages |
	logMessages  := OrderedCollection new.
	phases do: [ :phase | 
		logMessages add: 'Begin phase named ', phase name.
		logMessages add: 'End of phase named ', phase name.
	].
	self assert: (logger areTheseMessagesOrdered: logMessages).! !

!MECCGModelUsageExamples methodsFor: 'private' stamp: 'SergioFedi 5/2/2016 12:01'!
checkLogger: logger toMakeSureThePlayerOrderIsTheSameAsIn: players 
	| logMessages |
	logMessages  := players collect: [ :player | 
		'Begin turn of player ', player name ].
	self assert: logger logSize >= players size.
	self assert: (logger areTheseMessagesOrdered: logMessages).! !

!MECCGModelUsageExamples methodsFor: 'private' stamp: 'SergioFedi 5/6/2016 14:03'!
checkThatLastActionPlayedInEachPhaseIsEndPhaseInLogger: logger 

	| beginningsOfLogMessages |
	beginningsOfLogMessages  := Array 
		with: 'Begin phase'
		with: 'Action generic'
		with: 'Action EndPhase '
		with: 'End of phase'.
	self assert:
		(logger 
			areTheseMessagesOrdered: beginningsOfLogMessages 
			allowingMultipleInstancesOf: beginningsOfLogMessages second).! !

!MECCGModelUsageExamples methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 22:28'!
playMatch
	"Initialize the test variables and play a standard match"

	match := MECCGMatch new.
	logger := MECCGLogger on: match.
	logger logEvents: #somethingHappened.
	match player1: (MECCGPlayer named: 'Federico').
	match player2: (MECCGPlayer named: 'Sergio').
	players := match players.
	match board: MECCGBoard new.
	self assert: match isReadyForSetup.
	match setup.
	self assert: match isReadyForPlay.
	match play.
	match wrapUp.
	logger detach! !

!MECCGModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:28'!
test_01_SimpleUsage
	"Modelar empezar un juego con 2 jugadores que empieza (Game Setup),
	se juegan turnos y termina (Victory Condition)"

	| result |
	match := MECCGMatch new.
	match player1: (MECCGPlayer named: 'Fede Padawan').
	match player2: (MECCGPlayer named: 'Pieter').
	match board: MECCGBoard new.
	self assert: match isReadyForSetup.
	match setup.
	self assert: match isReadyForPlay.
	match play.
	match wrapUp.
	result := match result.
! !

!MECCGModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/7/2016 11:31'!
test_02_PlayerOrder
	"We test that the players go in the correct order."

	self playMatch.
	self checkLogger: logger toMakeSureThePlayerOrderIsTheSameAsIn: players! !

!MECCGModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/7/2016 11:22'!
test_03_LastActionOfThePhase
	"We test that, for each phase, the last action taken is the 'EndPhase' action."

	self playMatch.
	self checkThatLastActionPlayedInEachPhaseIsEndPhaseInLogger: logger.! !

!MECCGModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/7/2016 11:22'!
test_04_PhaseOrder
	"We test that the phases of the turn occur in the right order."

	self playMatch.
	self checkLogger: logger toMakeSureThePhaseOrderIsTheSameAsIn: match rules turnPhases.! !

!MECCGModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:28'!
test_05_MatchSetup

	match := MECCGMatch new.
	
	self deny: match isReadyForSetup.
	match player1: (MECCGPlayer named: 'Fede Padawan').
	self deny: match isReadyForSetup.
	match player2: (MECCGPlayer named: 'Pieter').
	self deny: match isReadyForSetup.
	match board: MECCGBoard new.
	self assert: match isReadyForSetup.
	match setup.! !

!MECCGModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:28'!
test_06_ResultEvolution
	"Modelar empezar un juego con N jugadores que empieza (Game Setup), 
	se juegan turnos y termina (Victory Condition)"

	| result |
	match := MECCGMatch new.
	match player1: (MECCGPlayer named: 'Fede Padawan').
	match player2: (MECCGPlayer named: 'Pieter').
	match board: MECCGBoard new.
	self assert: match isReadyForSetup.
	self assert: match result isNil.
	match setup.
	self assert: match result notNil.
	self assert: match result roundsFullyPlayed isNil.
	self assert: match isReadyForPlay.
	match play.
	match wrapUp.
	result := match result.
	self assert: result roundsFullyPlayed notNil.
	self assert: result winners notEmpty.
! !

!MECCGModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:29'!
test_07_LoggingAMatch
	"Modelar empezar un juego con N jugadores que empieza (Game Setup), 
	se juegan turnos y termina (Victory Condition)"

	| result |
	match := MECCGMatch new.
	logger := MECCGTranscriptLogger on: match.
	logger logEvents: #somethingHappened.
	logger logOn: Transcript.
	match player1: (MECCGPlayer named: 'Fede Padawan').
	match player2: (MECCGPlayer named: 'Pieter').
	match board: MECCGBoard new.
	self assert: match isReadyForSetup.
	match setup.
	self assert: match isReadyForPlay.
	match play.
	match wrapUp.
	result := match result.
	logger detach.! !

!MECCGModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:29'!
test_08_MatchKeepsTrackOfTurnsPlayedByEachPlayer

	| result roger rabbit |
	match := MECCGMatch new.
	roger := (MECCGPlayer named: 'Roger').
	rabbit := (MECCGPlayer named: 'Rabbit').
	match player1: roger.
	match player2: rabbit.
	match board: MECCGBoard new.
	self assert: match isReadyForSetup.
	match setup.
	self assert: (match result turnsPlayedBy: roger) = 0.
	self assert: (match result turnsPlayedBy: rabbit) = 0.
	self assert: match isReadyForPlay.
	match play.
	self assert: (match result turnsPlayedBy: roger) > 0.
	self assert: (match result turnsPlayedBy: rabbit) > 0.
	match wrapUp.
	result := match result.
! !

!MECCGModelUsageExamples methodsFor: 'public' stamp: 'FedericoFigueredo 5/12/2016 09:15'!
test_xx_MatchEndsWithAtLeastOneWinner
	
	self assert: false.! !

TestCase subclass: #MTGSBoardTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS-Tests-Unit'!

!MTGSBoardTest commentStamp: '<historical>' prior: 0!
A MTGSBoardTest is a test class for testing the behavior of MTGSBoard!

!MTGSBoardTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:02'!
test_01_BoardShouldHaveOneZoneForEachPlayer
	| board validator | 
	board := MTGSBoard new.
	validator := MTGSBoardValidator new.
	
	self assert: (validator isThereAZoneForEachPlayerIn: board).
	self assert: board zoneOfPlayer notNil.
	self assert: board zoneOfEnemy notNil.
	self assert: board zoneOfEnemy ~= board zoneOfPlayer.
! !

!MTGSBoardTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 23:13'!
test_02_PlayerHandIsValid
	| board validator |
	board := MTGSBoard new.
	validator := MTGSBoardValidator new.
	
	self assert: (board zones allSatisfy: [ :zone | validator isPlayerHandValidIn: zone ]).! !

!MTGSBoardTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:33'!
test_04_PlayerZoneShouldHaveValidPiles
	| board validator |
	board := MTGSBoard new.
	validator := MTGSBoardValidator new.
	self assert: (board zones allSatisfy: [ :zone | validator arePilesValidIn: zone ]).
	! !

!MTGSBoardTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:43'!
test_06_PlayerZoneShouldHaveSomewhereToPlayCards
	"Fede, I expect you to (define/find the definition of) this zone"

	self assert: true.
	! !

!MTGSBoardTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 23:13'!
test_XX_BoardIsValid
	| board validator |
	board := MTGSBoard new.
	validator := MTGSBoardValidator new.
	
	self assert: (validator isValid: board).! !

TestCase subclass: #MTGSDrawCardActionTest
	instanceVariableNames: 'hasBeenAskedToHandleSuccessOfAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS-Tests-Unit'!

!MTGSDrawCardActionTest commentStamp: '<historical>' prior: 0!
A MTGSDrawCardActionTest is a test class for testing the behavior of MTGSDrawCardAction!

!MTGSDrawCardActionTest methodsFor: 'private' stamp: 'SergioFedi 5/22/2016 01:57'!
handleSuccessOfAction: aMTGSDrawCardAction

	self hasBeenAskedToHandleSuccessOfAction: true.! !

!MTGSDrawCardActionTest methodsFor: 'private' stamp: 'SergioFedi 5/22/2016 01:53'!
hasBeenAskedToHandleSuccessOfAction

	^hasBeenAskedToHandleSuccessOfAction.! !

!MTGSDrawCardActionTest methodsFor: 'private' stamp: 'SergioFedi 5/22/2016 01:55'!
hasBeenAskedToHandleSuccessOfAction: aBoolean 

	hasBeenAskedToHandleSuccessOfAction := aBoolean.! !

!MTGSDrawCardActionTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:54'!
setUp
	super setUp.
	self hasBeenAskedToHandleSuccessOfAction: false.! !

!MTGSDrawCardActionTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 00:26'!
test_01_New

	| action |
	action := MTGSDrawCardAction new.
	self assert: action actor isNil.
	self assert: action match isNil.
	self assert: action phase isNil.! !

!MTGSDrawCardActionTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 02:00'!
test_02_Creation

	| match player phase action |
	match := MTGSMatch new.
	player := MTGSPlayer new.
	phase := MTGSDrawPhase new.
	player match: match.
	action := MTGSDrawCardAction phase: phase.
	action player: player.
	self assert: action actor = player.
	self assert: action match = match.
	action phase: phase.! !

!MTGSDrawCardActionTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:57'!
test_03_WhenPerformedItsPhaseIsNotified

	| match player  action |
	match := MTGSMatch new.
	player := MTGSPlayer new.
	player match: match.
	action := MTGSDrawCardAction phase: self. "We are mocking here"

	self deny: self hasBeenAskedToHandleSuccessOfAction.
	action perform.
	self assert: self hasBeenAskedToHandleSuccessOfAction.! !

TestCase subclass: #MTGSDrawPhaseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS-Tests-Unit'!

!MTGSDrawPhaseTest commentStamp: '<historical>' prior: 0!
A MTGSDrawPhaseTest is a test class for testing the behavior of MTGSDrawPhase!

!MTGSDrawPhaseTest methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 23:28'!
newPlayer

	^(MTGSPlayer named: 'test player') match: MTGSMatch new.! !

!MTGSDrawPhaseTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:11'!
test_01_Creation

	| phase |
	phase := MTGSDrawPhase new.
	self assert: phase name = 'Draw'.
	self assert: (phase remainingDraws = 1).
	self assert: phase actions size = 2.! !

!MTGSDrawPhaseTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 23:33'!
test_02_AvailableActionsWhenPhaseHasDraws

	| phase player |
	player := self newPlayer.
	phase := MTGSDrawPhase new.
	self assert: phase remainingDraws > 0.
	self assert: (phase availableActionsForPlayer: player) size = 1.
	self assert: (phase availableActionsForPlayer: player) first endsPhase not.
! !

!MTGSDrawPhaseTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:43'!
test_03_AvailableActionsWhenPhaseHasNoDraws

	| phase player |
	player := self newPlayer.
	phase := MTGSDrawPhase new.
	phase actions removeLast.
	self assert: (phase availableActionsForPlayer: player) size = 1.
	self assert: (phase availableActionsForPlayer: player) first endsPhase.
! !

!MTGSDrawPhaseTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:06'!
test_04_Use

	| match player phase |
	match := MTGSMatch new.
	player := MTGSPlayer named: 'Ruperto'.
	player match: match.
	phase := MTGSDrawPhase new.
	phase beginIn: match.
	phase availableActionsForPlayer: player.
	phase endIn: match.! !

!MTGSDrawPhaseTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:47'!
test_05_RemovesDrawActionOncePerformed

	| match player phase drawAction |
	match := MTGSMatch new.
	player := MTGSPlayer named: 'Ruperto'.
	player match: match.
	phase := MTGSDrawPhase new.
	drawAction := phase actions last.
	self assert: (phase actions includes: drawAction).

	phase handleSuccessOfAction: drawAction.

	self assert: phase actions size = 1.
	self assert: phase actions last endsPhase.
	self assert: phase actions first endsPhase.
	self assert: (phase actions includes: drawAction) not.! !

TestCase subclass: #MTGSMatchSetupRules
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS-Tests-Integration'!

!MTGSMatchSetupRules commentStamp: 'SergioFedi 5/22/2016 11:05' prior: 0!
This integration tests are for the rules of setting up a match of Magic The Gathering Solitaire.!

!MTGSMatchSetupRules methodsFor: 'private' stamp: 'SergioFedi 5/22/2016 12:14'!
cardsForEnemy

	| cards |
	cards := OrderedCollection new: 60.
	60 timesRepeat: [ cards add: Card new ].
	^cards.! !

!MTGSMatchSetupRules methodsFor: 'private' stamp: 'SergioFedi 5/22/2016 12:05'!
cardsForPlayer

	| cards |
	cards := OrderedCollection new: 60.
	60 timesRepeat: [ cards add: Card new ].
	^cards.! !

!MTGSMatchSetupRules methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:13'!
test_01_HowToSetupCorrectly

	| match  |
	match := MTGSMatch of: MagicSolitaireCardGame rules.
	match enemy: (MTGSPlayer named: 'Solitaire AI').
	match player: (MTGSHumanPlayer named: 'Sergio').
	match board: MTGSBoard new.
	match board zoneOfPlayer libraryPile addCards: self cardsForPlayer.
	match board zoneOfEnemy libraryPile addCards: self cardsForEnemy.
"	These other alternatives, while more natural, made Match bloated with methods.
	I suspect that all the logic of setting up a match will be on another object
	which will provide better methods and handle it more smoothly
	match add: Card new to: LibraryPile of: match player.
	(match pileNamed: 'Library' from: match player) addCard: Card new.
"	self assert: match isReadyForSetup.
	match setup.! !

!MTGSMatchSetupRules methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:19'!
test_02_MissingPlayer

	| match  |
	match := MTGSMatch of: MagicSolitaireCardGame rules.
	match enemy: (MTGSPlayer named: 'Solitaire AI').

	match board: MTGSBoard new.
	match board zoneOfPlayer libraryPile addCards: self cardsForPlayer.
	match board zoneOfEnemy libraryPile addCards: self cardsForEnemy.
	self deny: match isReadyForSetup.
! !

!MTGSMatchSetupRules methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:20'!
test_03_MissingEnemy

	| match  |
	match := MTGSMatch of: MagicSolitaireCardGame rules.

	match player: (MTGSPlayer named: 'Sergio').
	match board: MTGSBoard new.
	match board zoneOfPlayer libraryPile addCards: self cardsForPlayer.
	match board zoneOfEnemy libraryPile addCards: self cardsForEnemy.
	self deny: match isReadyForSetup.
! !

!MTGSMatchSetupRules methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:20'!
test_04_MissingBoard

	| match  |
	match := MTGSMatch of: MagicSolitaireCardGame rules.
	match enemy: (MTGSPlayer named: 'Solitaire AI').
	match player: (MTGSHumanPlayer named: 'Sergio').
	match board: nil.


	self deny: match isReadyForSetup.
! !

!MTGSMatchSetupRules methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:21'!
test_05_PlayerWithoutCardsInLibrary

	| match  |
	match := MTGSMatch of: MagicSolitaireCardGame rules.
	match enemy: (MTGSPlayer named: 'Solitaire AI').
	match player: (MTGSHumanPlayer named: 'Sergio').
	match board: MTGSBoard new.
	
	match board zoneOfEnemy libraryPile addCards: self cardsForEnemy.
	self deny: match isReadyForSetup.
! !

!MTGSMatchSetupRules methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:21'!
test_06_EnemyWithoutCardsInLibrary

	| match  |
	match := MTGSMatch of: MagicSolitaireCardGame rules.
	match enemy: (MTGSPlayer named: 'Solitaire AI').
	match player: (MTGSHumanPlayer named: 'Sergio').
	match board: MTGSBoard new.
	match board zoneOfPlayer libraryPile addCards: self cardsForPlayer.
	
	self deny: match isReadyForSetup.
! !

!MTGSMatchSetupRules methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 16:47'!
test_07_MissingRules

	| match  |
	match := MTGSMatch new.
	match enemy: (MTGSPlayer named: 'Solitaire AI').
	match player: (MTGSHumanPlayer named: 'Sergio').
	match board: MTGSBoard new.
	match board zoneOfPlayer libraryPile addCards: self cardsForPlayer.
	match board zoneOfEnemy libraryPile addCards: self cardsForEnemy.
	self deny: match isReadyForSetup.
! !

TestCase subclass: #MTGSMatchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS-Tests-Unit'!

!MTGSMatchTest commentStamp: '<historical>' prior: 0!
A MTGSMatchTest is a test class for testing the behavior of MTGSMatch!

!MTGSMatchTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/11/2016 16:46'!
test_01_SetPlayerToTheMatch

	| match |
	match := MTGSMatch new.
	self assert: match player isNil.
	match player: (MTGSPlayer named: 'Fede').
	self assert: match player notNil.
	self assert: match player name = 'Fede'.
! !

!MTGSMatchTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/11/2016 11:07'!
test_02_SetEnemyToTheMatch

	| match |
	match := MTGSMatch new.
	self assert: match enemy isNil.
	match enemy: (MTGSPlayer named: 'Mandingo').
	self assert: match enemy notNil.
	self assert: match enemy name = 'Mandingo'.
! !

!MTGSMatchTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/17/2016 13:39'!
test_03_PlayersKnowTheMatch

	| match player1 player2 |
	player1 := MECCGPlayer named: 'Fede'.	
	player2 := MECCGPlayer named: 'Ser'.	
	match := MTGSMatch new.
	match
		player: player1;
		enemy: player2.
	self assert: match player match = match.
	self assert: match enemy match = match.
	self assert: (match players allSatisfy: [:player | player match = match]).! !

TestCase subclass: #MTGSModelUsageExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS-Tests-Integration'!

!MTGSModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:59'!
test_01_SimpleUsage
	"Modelar empezar un juego con 2 jugadores que empieza (Game Setup), 
	se juegan turnos y termina (Victory Condition)"

	| match result |
	match := MTGSMatch of: MagicSolitaireCardGame rules.
	match enemy: (MTGSPlayer named: 'Solitaire AI').
	match player: (MTGSHumanPlayer named: 'Sergio').
	match board: MTGSBoard new.
	self assert: match isReadyForSetup.
	match setup.
	self assert: match isReadyForPlay.
	match play.
	match wrapUp.
	result := match result.
! !

!MTGSModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:59'!
test_02_ResultEvolution
	"Modelar empezar un juego con 2 jugadores que empieza (Game Setup), 
	se juegan turnos y termina (Victory Condition)"

	| result match |
	match := MTGSMatch of: MagicSolitaireCardGame rules.
	match enemy: (MTGSPlayer named: 'Solitaire AI').
	match player: (MTGSHumanPlayer named: 'Sergio').
	match board: MTGSBoard new.
	self assert: match result isNil.
	self assert: match isReadyForSetup.
	match setup.
	self assert: match result notNil.
	self assert: match isReadyForPlay.
	self assert: match result roundsFullyPlayed isNil.
	match play.
	match wrapUp.
	result := match result.
	self assert: result roundsFullyPlayed notNil.
! !

!MTGSModelUsageExamples methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:59'!
test_03_LoggingMatch
	"Modelar empezar un juego con 2 jugadores que empieza (Game Setup), 
	se juegan turnos y termina (Victory Condition)"

	| match logger |
	match := MTGSMatch of: MagicSolitaireCardGame rules.
	logger := MECCGLogger on: match.
	logger logEvents: #somethingHappened.
	match enemy: (MTGSPlayer named: 'Solitaire AI').
	match player: (MTGSHumanPlayer named: 'Sergio').
	match board: MTGSBoard new.
	self assert: match isReadyForSetup.
	match setup.
	self assert: match isReadyForPlay.
	match play.
	match wrapUp.
	logger detach.! !

TestCase subclass: #MTGSPlayerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS-Tests-Unit'!

!MTGSPlayerTest commentStamp: '<historical>' prior: 0!
A MTGSPlayerTest is a test class for testing the behavior of MTGSPlayer!

!MTGSPlayerTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/19/2016 23:44'!
test_01_Creation

	| player |
	player := MTGSPlayer new.
	self assert: player hitPoints = 20.
	self assert: player name isNil.
	self assert: player match isNil.! !

!MTGSPlayerTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/19/2016 23:34'!
test_02_DecrementHitPoints

	| player |
	player := MTGSPlayer new.
	player reduceHitpointsBy: 3.
	self assert: player hitPoints = 17.! !

!MTGSPlayerTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/19/2016 23:45'!
test_03_CreationByConstructor

	| player |
	player := MTGSPlayer named: 'Bartolo'.
	self assert: player hitPoints = 20.
	self assert: player name = 'Bartolo'.
	self assert: player match isNil.! !

!MTGSPlayerTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/19/2016 23:47'!
test_04_MatchSetter

	| player match |
	match := MTGSMatch new.
	player := MTGSPlayer new.
	self assert: player match isNil.
	player match: match.
	self assert: player match = match.! !

TestCase subclass: #MagicSolitaireCardGameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS-Tests-Unit'!

!MagicSolitaireCardGameTest commentStamp: '<historical>' prior: 0!
A MagicSolitaireCardGameTest is a test class for testing the behavior of MagicSolitaireCardGame!

!MagicSolitaireCardGameTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:31'!
test_01_GameHasRules

	self assert: MagicSolitaireCardGame rules notNil.! !

TestCase subclass: #MatchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!MatchTest commentStamp: '<historical>' prior: 0!
A MatchTest is a test class for testing the behavior of Match!

!MatchTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:26'!
test_01_NewMatchHasEmptyVicotryConditions

	| match |
	match := Match new.
	self assert: match victoryConditions isEmpty.! !

TestCase subclass: #MiddleEarthCardGameRulesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!MiddleEarthCardGameRulesTest commentStamp: '<historical>' prior: 0!
A MiddleEarthCardGameRulesTest is a test class for testing the behavior of MiddleEarthCardGameRules!

!MiddleEarthCardGameRulesTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:23'!
test_01_KnowsAMatchIsNotReady

	| rules |
	rules := MiddleEarthCardGameRules new.
	self deny: (rules isMatchReady: MECCGMatch new).! !

TestCase subclass: #MiddleEarthCardGameTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!MiddleEarthCardGameTest commentStamp: '<historical>' prior: 0!
A MiddleEarthCardGameTest is a test class for testing the behavior of MiddleEarthCardGame!

!MiddleEarthCardGameTest methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:59'!
test_01_CardGameHasRules

	self assert: MiddleEarthCardGame rules notNil.! !

TestCase subclass: #PileTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model-Tests-Unit'!

!PileTest commentStamp: '<historical>' prior: 0!
A PileTest is a test class for testing the behavior of Pile!

!PileTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:10'!
test_01_Creation

	| pile |
	pile := Pile new.
	self assert: pile cards notNil.
	self assert: pile isEmpty.! !

!PileTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:07'!
test_02_Size

	| pile |
	pile := Pile new.
	self assert: pile size = 0.! !

!PileTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:07'!
test_03_AddCard

	| pile |
	pile := Pile new.
	pile addCard: Card new.
	self assert: pile notEmpty.
	self assert: pile size = 1.! !

!PileTest methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:13'!
test_04_AddCards

	| pile |
	pile := Pile new.
	pile addCards: (Array with: Card new with: Card new).
	self assert: pile notEmpty.
	self assert: pile size = 2.! !

Object subclass: #Action
	instanceVariableNames: 'actor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!Action commentStamp: 'SergioFedi 5/7/2016 11:13' prior: 0!
I model the action that a player takes during his turn.
!

!Action methodsFor: 'public' stamp: 'SergioFedi 4/26/2016 09:07'!
actor
	^ actor! !

!Action methodsFor: 'public' stamp: 'SergioFedi 4/26/2016 09:07'!
actor: anObject
	actor := anObject! !

!Action methodsFor: 'public' stamp: 'FedericoFigueredo 5/5/2016 09:13'!
name

	^'generic'.! !

!Action methodsFor: 'public' stamp: 'SergioFedi 4/26/2016 09:06'!
perform
! !

Action subclass: #MatchAction
	instanceVariableNames: 'match'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MatchAction commentStamp: 'SergioFedi 5/8/2016 21:38' prior: 0!
I model the action that a player takes during his turn in a game.
!

MatchAction subclass: #MECCGAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MECCGAction commentStamp: 'SergioFedi 5/8/2016 21:42' prior: 0!
I model the action that a player takes during a match of Middle Earth Collectible Card Game.
!

MECCGAction subclass: #EndPhaseAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!EndPhaseAction commentStamp: 'SergioFedi 5/7/2016 11:13' prior: 0!
I model the action of ending a phase.!

!EndPhaseAction methodsFor: 'public' stamp: 'FedericoFigueredo 5/5/2016 09:10'!
endsPhase

	^true.! !

!EndPhaseAction methodsFor: 'public' stamp: 'FedericoFigueredo 5/5/2016 09:14'!
name

	^'EndPhase'.! !

MatchAction subclass: #MTGSAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSAction commentStamp: 'SergioFedi 5/8/2016 21:42' prior: 0!
I model the action that a player takes during a match of Magic The Gathering Solitaire.!

MTGSAction subclass: #MTGSAttackAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSAttackAction commentStamp: 'SergioFedi 5/8/2016 21:43' prior: 0!
I model the attack action that a player takes during a match of Magic The Gathering Solitaire.!

!MTGSAttackAction methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:49'!
perform

	self match enemy reduceHitpointsBy: 3.! !

MTGSAction subclass: #MTGSDrawCardAction
	instanceVariableNames: 'phase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSDrawCardAction commentStamp: 'SergioFedi 5/21/2016 23:11' prior: 0!
I model the action of drawing a card that a player takes during a match of Magic The Gathering Solitaire.!

!MTGSDrawCardAction class methodsFor: 'instance creation' stamp: 'SergioFedi 5/22/2016 01:18'!
phase: aPhase

	^self new phase: aPhase.! !

!MTGSDrawCardAction methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:56'!
perform

	self phase handleSuccessOfAction: self.! !

!MTGSDrawCardAction methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 00:25'!
phase
	^ phase! !

!MTGSDrawCardAction methodsFor: 'private' stamp: 'SergioFedi 5/22/2016 00:25'!
phase: anObject
	phase := anObject! !

!MTGSDrawCardAction methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 23:11'!
player: aMTGSPlayer

	self actor: aMTGSPlayer.
	self match: aMTGSPlayer match.! !

!MatchAction class methodsFor: 'instance creation' stamp: 'SergioFedi 5/8/2016 21:40'!
match: aMatch

	^self new match: aMatch.! !

!MatchAction methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:39'!
endsPhase

	^false.! !

!MatchAction methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:39'!
match
	^ match! !

!MatchAction methodsFor: 'private' stamp: 'SergioFedi 5/8/2016 21:39'!
match: anObject
	match := anObject! !

Object subclass: #BoardZone
	instanceVariableNames: 'piles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!BoardZone commentStamp: 'FedericoFigueredo 5/12/2016 08:29' prior: 0!
This models a logical section of the GameBoard.!

!BoardZone methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:29'!
hand

	^self pileNamed: 'Hand'.! !

!BoardZone methodsFor: 'public' stamp: 'FedericoFigueredo 5/12/2016 09:06'!
pileNamed: aString 
	^ self piles at: aString.! !

!BoardZone methodsFor: 'public' stamp: 'FedericoFigueredo 5/12/2016 09:07'!
piles
	^ piles! !

BoardZone subclass: #MECCGBoardZone
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MECCGBoardZone commentStamp: 'SergioFedi 5/21/2016 19:54' prior: 0!
This models a logical section of the GameBoard of a Middle Earth Collectible Card Game.!

!MECCGBoardZone methodsFor: 'public' stamp: 'SergioFedi 5/15/2016 16:07'!
discardPile

	^self pileNamed: 'Discard'.! !

!MECCGBoardZone methodsFor: 'initialization' stamp: 'SergioFedi 5/22/2016 10:30'!
initialize

	super initialize.
	piles := Dictionary
		with: 'Play' -> Pile new
		with: 'Discard' -> Pile new
		with: 'Out of Play' -> Pile new
		with: 'Marshalling' -> Pile new
		with: 'Hand' -> Pile new.
! !

!MECCGBoardZone methodsFor: 'public' stamp: 'SergioFedi 5/15/2016 16:07'!
marshallingPile

	^self pileNamed: 'Marshalling'.! !

!MECCGBoardZone methodsFor: 'public' stamp: 'SergioFedi 5/15/2016 16:07'!
outOfPlayPile

	^self pileNamed: 'Out of Play'.! !

!MECCGBoardZone methodsFor: 'public' stamp: 'SergioFedi 5/15/2016 16:07'!
playPile

	^self pileNamed: 'Play'.! !

BoardZone subclass: #MTGSBoardZone
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSBoardZone commentStamp: 'SergioFedi 5/15/2016 18:58' prior: 0!
This models a zone on the game board of a MTGS game.!

!MTGSBoardZone methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/22/2016 10:44'!
initialize

	super initialize.
	piles := Dictionary
		with: 'Hand' -> Pile new
		with: 'Library' -> Pile new.! !

!MTGSBoardZone methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:43'!
libraryPile

	^self pileNamed: 'Library'.! !

Object subclass: #Card
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

Object subclass: #CardGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!CardGame commentStamp: 'SergioFedi 5/8/2016 01:22' prior: 0!
I model a Card Game.
I can answer the rules of the game.!

!CardGame class methodsFor: 'instance creation' stamp: 'SergioFedi 5/8/2016 01:20'!
rules
	self subclassResponsibility! !

CardGame subclass: #MagicSolitaireCardGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MagicSolitaireCardGame commentStamp: 'SergioFedi 5/8/2016 01:24' prior: 0!
I model a Solitaire variation of the Magic The Gathering Card Game.
I can answer the rules of the game.
!

!MagicSolitaireCardGame class methodsFor: 'instance creation' stamp: 'SergioFedi 5/8/2016 01:31'!
rules

	^MagicSolitaireCardGameRules new.! !

CardGame subclass: #MiddleEarthCardGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MiddleEarthCardGame commentStamp: 'SergioFedi 4/21/2016 08:31' prior: 0!
I model the game of Middle Earth Collectible Card Game.
I can answer the rules of the game.
!

!MiddleEarthCardGame class methodsFor: 'instance creation' stamp: 'SergioFedi 4/17/2016 17:09'!
rules

	^MiddleEarthCardGameRules new.! !

Object subclass: #CardGameRules
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!CardGameRules commentStamp: 'SergioFedi 5/8/2016 01:29' prior: 0!
I model the rules of a Card Game.

My responsibility is to run matches of that game.
!

!CardGameRules methodsFor: 'private' stamp: 'SergioFedi 5/8/2016 01:42'!
incrementRoundCountOf: aMatch

	aMatch result roundsFullyPlayed: aMatch result roundsFullyPlayed + 1.! !

!CardGameRules methodsFor: 'private' stamp: 'SergioFedi 5/8/2016 01:41'!
initializeRoundCountOf: aMatch 

	aMatch result roundsFullyPlayed: 0.! !

!CardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 01:47'!
isMatchReady: aMatch

	^self subclassResponsibility.! !

!CardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 01:33'!
isMatchReadyForSetup: aMatch

	^self subclassResponsibility.! !

!CardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 01:48'!
play: aMatch

	^self subclassResponsibility.! !

!CardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 01:36'!
setupMatch: aMatch

	aMatch result: MatchOutcome new.
	^self.! !

!CardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 01:48'!
wrapUpMatch: aMatch
	
	^self subclassResponsibility.! !

CardGameRules subclass: #MagicSolitaireCardGameRules
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MagicSolitaireCardGameRules commentStamp: 'SergioFedi 5/8/2016 01:30' prior: 0!
I model the rules of Magic The Gathering Solitaire Card Game.

My responsibility is to run matches of that game.
!

!MagicSolitaireCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 19:15'!
isFinished: aMatch

	(aMatch player hitPoints <= 0) ifTrue: [^true].
	(aMatch enemy hitPoints <= 0) ifTrue: [^true].
	^false.! !

!MagicSolitaireCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 01:39'!
isMatchReady: aMatch

	^true.! !

!MagicSolitaireCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 16:49'!
isMatchReadyForSetup: aMatch

	aMatch player ifNil: [ ^false ].
	aMatch enemy ifNil: [ ^false ].
	aMatch board ifNil: [ ^false ].
	aMatch rules ifNil: [ ^false ].
	(aMatch board zoneOfPlayer libraryPile size < 60) ifTrue: [ ^false ].
	(aMatch board zoneOfEnemy libraryPile size < 60) ifTrue: [ ^false ].
	^true.! !

!MagicSolitaireCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:48'!
performAction: anAction 

	anAction perform.! !

!MagicSolitaireCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 19:12'!
play: aMatch
	"Play the match until it is finished"

	self initializeRoundCountOf: aMatch.
	[self isFinished: aMatch] whileFalse: [
			self playRoundOf: aMatch.
			self incrementRoundCountOf: aMatch.
	].! !

!MagicSolitaireCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:45'!
playPhase: phase ofPlayer: aPlayer
	| keepPlayingPlayerActions |
	aPlayer match beginPhase: phase ofPlayer: aPlayer.
	phase beginIn: aPlayer match.
	keepPlayingPlayerActions := true.
	[ keepPlayingPlayerActions ]
		whileTrue: [ 
			| chosenAction |
			chosenAction := aPlayer chooseActionAmong: (phase availableActionsForPlayer: aPlayer).
			self performAction: chosenAction.
			aPlayer match player: aPlayer played: chosenAction.
			keepPlayingPlayerActions := chosenAction endsPhase not ].
	phase endIn: aPlayer match.
	^ aPlayer match endPhase: phase ofPlayer: aPlayer! !

!MagicSolitaireCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 19:36'!
playRoundOf: aMatch
	aMatch players
		do: [ :player | 
			self playTurnOf: player.
			(self isFinished: aMatch)
				ifTrue: [ ^ self ] ]! !

!MagicSolitaireCardGameRules methodsFor: 'private' stamp: 'SergioFedi 5/8/2016 19:38'!
playTurnOf: aPlayer
	aPlayer match beginTurnOf: aPlayer.
	self turnPhases do: [ :phase | self playPhase: phase ofPlayer: aPlayer ].
	aPlayer match endTurnOf: aPlayer! !

!MagicSolitaireCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 23:16'!
turnPhases

	^Array
		with: (MTGSPhase named: 'Untap')
		with: (MTGSDrawPhase new)
		with: (MTGSPhase named: 'Main 1')
		with: (MTGSPhase named: 'Attack')
		with: (MTGSPhase named: 'Main 2')
		with: (MTGSPhase named: 'End of Turn').! !

!MagicSolitaireCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 01:39'!
wrapUpMatch: aMatch
	! !

CardGameRules subclass: #MiddleEarthCardGameRules
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MiddleEarthCardGameRules commentStamp: 'SergioFedi 4/21/2016 08:36' prior: 0!
I model the rules of the Middle Earth Card Game.

My responsibility is to run matches of that game.
!

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'SergioFedi 4/22/2016 09:01'!
isFinished: aMatch

	^aMatch result isFinished.! !

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'SergioFedi 4/17/2016 17:34'!
isMatchReady: aMatch

	^true.! !

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/19/2016 08:14'!
isMatchReadyForSetup: aMatch

	(aMatch players size ~= 2) ifTrue: [^ false].
	(self isValidBoard: aMatch board inMatch: aMatch) ifFalse: [^ false].
	self assert: aMatch board zones first marshallingPile isEmpty.
	self assert: aMatch board zones first outOfPlayPile isEmpty.
	self assert: aMatch board zones first discardPile isEmpty.
	self assert: aMatch board zones second marshallingPile isEmpty.
	self assert: aMatch board zones second outOfPlayPile isEmpty.
	self assert: aMatch board zones second discardPile isEmpty.
	^ true.! !

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'FedericoFigueredo 5/10/2016 09:18'!
isValidBoard: aMECCGBoard inMatch: aMatch 
	| validator |
	(aMatch board isNil) ifTrue: [^ false].
	validator := MECCGBoardValidator new.
	^ validator isValid: aMECCGBoard.! !

!MiddleEarthCardGameRules methodsFor: 'private' stamp: 'FedericoFigueredo 5/5/2016 09:18'!
performAction: anAction ! !

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'SergioFedi 4/25/2016 12:26'!
play: aMatch
	"Play the match until it is finished"

	self initializeRoundCountOf: aMatch.
	[self isFinished: aMatch] whileFalse: [
			self playRoundOf: aMatch.
			self incrementRoundCountOf: aMatch.
	].
! !

!MiddleEarthCardGameRules methodsFor: 'private' stamp: 'SergioFedi 5/8/2016 21:45'!
playPhase: phase ofPlayer: aPlayer
	| keepPlayingPlayerActions |
	aPlayer match beginPhase: phase ofPlayer: aPlayer.
	phase beginIn: aPlayer match.
	keepPlayingPlayerActions := true.
	[ keepPlayingPlayerActions ]
		whileTrue: [ 
			| chosenAction |
			chosenAction := aPlayer chooseActionAmong: (phase availableActionsForPlayer: aPlayer).
			self performAction: chosenAction.
			aPlayer match player: aPlayer played: chosenAction.
			keepPlayingPlayerActions := chosenAction endsPhase not ].
	phase endIn: aPlayer match.
	^ aPlayer match endPhase: phase ofPlayer: aPlayer! !

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 19:36'!
playRoundOf: aMatch
	aMatch players
		do: [ :player | 
			self playTurnOf: player.
			(self isFinished: aMatch)
				ifTrue: [ ^ self ] ]! !

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 19:37'!
playTurnOf: aPlayer
	aPlayer match beginTurnOf: aPlayer.
	self turnPhases do: [ :phase | self playPhase: phase ofPlayer: aPlayer ].
	aPlayer match endTurnOf: aPlayer! !

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/19/2016 08:38'!
setupMatch: aMatch

	super setupMatch: aMatch.
	aMatch addVictoryCondition: self turnsPlayedVictoryCondition.
	aMatch installVictoryConditionsDetectors.
	^self.! !

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'FedericoFigueredo 5/6/2016 09:04'!
turnPhases

	^Array
		with: (MECCGPhase named: 'Untap')
		with: (MECCGPhase named: 'Organization')
		with: (MECCGPhase named: 'Long Event')
		with: (MECCGPhase named: 'Movement / Hazard')
		with: (MECCGPhase named: 'Site')
		with: (EndOfTurnPhase named: 'End of Turn').
		! !

!MiddleEarthCardGameRules methodsFor: 'private' stamp: 'SergioFedi 5/19/2016 08:39'!
turnsPlayedVictoryCondition
	^ TurnsPlayedVictoryCondition named: 'Turns Played'.! !

!MiddleEarthCardGameRules methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 18:30'!
wrapUpMatch: aMatch 
	
	aMatch uninstallVictoryConditionsDetectors.
	aMatch result winners: 'A'. ! !

Object subclass: #GameBoard
	instanceVariableNames: 'zones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!GameBoard commentStamp: 'SergioFedi 5/8/2016 14:47' prior: 0!
I model the board of a game.!

!GameBoard methodsFor: 'initialization' stamp: 'FedericoFigueredo 5/12/2016 08:26'!
initialize

	super initialize.
! !

!GameBoard methodsFor: 'public' stamp: 'SergioFedi 5/15/2016 16:15'!
zones
	^ zones.! !

GameBoard subclass: #MECCGBoard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MECCGBoard commentStamp: 'SergioFedi 5/8/2016 14:47' prior: 0!
I model the board of a Middle Earth Collectible Card Game.!

!MECCGBoard methodsFor: 'initialization' stamp: 'SergioFedi 5/15/2016 16:07'!
initialize

	super initialize.
	zones := Array with: MECCGBoardZone new with: MECCGBoardZone new.
! !

GameBoard subclass: #MTGSBoard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSBoard commentStamp: 'SergioFedi 5/8/2016 14:48' prior: 0!
I model the board of a Magic The Gathering Solitaire Game.!

!MTGSBoard methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/15/2016 16:14'!
initialize

	super initialize.
	zones := Array with: MTGSBoardZone new with: MTGSBoardZone new.
! !

!MTGSBoard methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:02'!
zoneOfEnemy

	^self zones second.! !

!MTGSBoard methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:01'!
zoneOfPlayer

	^self zones first.! !

Object subclass: #MECCGListener
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support'!

!MECCGListener commentStamp: 'SergioFedi 4/29/2016 09:46' prior: 0!
I am a Listener (as in the Observer pattern) of MECCG Games, Matches, Players, etc.
!

!MECCGListener class methodsFor: 'instance creation' stamp: 'SergioFedi 4/29/2016 09:55'!
on: anObject

	^self new source: anObject.! !

!MECCGListener methodsFor: 'public' stamp: 'SergioFedi 4/29/2016 09:49'!
detach

	self source removeActionsWithReceiver: self.! !

!MECCGListener methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 10:43'!
handleEventOccurence: aString
	self subclassResponsibility! !

!MECCGListener methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 10:43'!
logEvents: aSymbol

	self source 
		when: aSymbol
		send: #handleEventOccurence:
		to: self.! !

!MECCGListener methodsFor: 'public' stamp: 'SergioFedi 4/29/2016 09:49'!
source
	^ source! !

!MECCGListener methodsFor: 'private' stamp: 'SergioFedi 4/29/2016 09:49'!
source: anObject
	source := anObject! !

MECCGListener subclass: #MECCGLogger
	instanceVariableNames: 'log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support'!

!MECCGLogger commentStamp: 'SergioFedi 4/29/2016 09:51' prior: 0!
I listen to events of a MECCG and log them in a collection.!

!MECCGLogger methodsFor: 'public' stamp: 'FedericoFigueredo 5/5/2016 08:29'!
areTheseMessagesOrdered: aSequenceableCollection

	^self log isSubstringOfInfiniteLoopGeneratedBy: aSequenceableCollection.! !

!MECCGLogger methodsFor: 'public' stamp: 'SergioFedi 5/3/2016 11:43'!
areTheseMessagesOrdered: aCollection allowingMultipleInstancesOf: aString

	^self log areTheseStringsOrdered: aCollection allowingZeroOrMoreInstancesOf: aString.! !

!MECCGLogger methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 10:43'!
handleEventOccurence: aString

	self log add: aString.! !

!MECCGLogger methodsFor: 'private' stamp: 'SergioFedi 5/2/2016 11:10'!
initialize

	self log: StringOfObjects new.! !

!MECCGLogger methodsFor: 'private' stamp: 'SergioFedi 4/29/2016 09:53'!
log
	^ log! !

!MECCGLogger methodsFor: 'private' stamp: 'SergioFedi 4/29/2016 09:53'!
log: anObject
	log := anObject! !

!MECCGLogger methodsFor: 'public' stamp: 'SergioFedi 5/2/2016 12:09'!
logSize

	^self log size.! !

MECCGListener subclass: #MECCGTranscriptLogger
	instanceVariableNames: 'sink'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support'!

!MECCGTranscriptLogger commentStamp: 'SergioFedi 4/28/2016 16:58' prior: 0!
This class listens other objects and logs the events that are of interest.!

!MECCGTranscriptLogger methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 10:43'!
handleEventOccurence: aString

	self sink nextPutAll: aString.
	self sink cr.
	self sink flush.! !

!MECCGTranscriptLogger methodsFor: 'public' stamp: 'SergioFedi 4/28/2016 19:55'!
logOn: aThreadSafeTranscript

	self sink: aThreadSafeTranscript.! !

!MECCGTranscriptLogger methodsFor: 'private' stamp: 'SergioFedi 4/28/2016 19:48'!
sink
	^ sink! !

!MECCGTranscriptLogger methodsFor: 'private' stamp: 'SergioFedi 4/28/2016 19:48'!
sink: anObject
	sink := anObject! !

MECCGListener subclass: #VictoryConditionDetector
	instanceVariableNames: 'victoryCondition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support'!

!VictoryConditionDetector commentStamp: 'SergioFedi 5/21/2016 19:04' prior: 0!
I listen to a match and detect when a Victory Condition is fulfilled.!

VictoryConditionDetector subclass: #TurnsPlayedVictoryConditionDetector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support'!

!TurnsPlayedVictoryConditionDetector commentStamp: 'SergioFedi 5/21/2016 19:04' prior: 0!
I listen to a match and detect when a certain amount of turns have been played.!

!TurnsPlayedVictoryConditionDetector methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 18:40'!
checkTurnThreshold
	(self victoryCondition turnsPlayed > self victoryCondition turnsThreshold) ifTrue: [
		self victoryCondition fulfilled].! !

!TurnsPlayedVictoryConditionDetector methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 18:40'!
handleEventOccurence: aString 
	(aString beginsWith: 'End turn of player ') ifTrue: self checkTurnThreshold.! !

!VictoryConditionDetector methodsFor: 'public' stamp: 'FedericoFigueredo 5/20/2016 09:35'!
install
	self logEvents: #somethingHappened.
! !

!VictoryConditionDetector methodsFor: 'public' stamp: 'FedericoFigueredo 5/17/2016 09:20'!
match

	^ self source.! !

!VictoryConditionDetector methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:03'!
uninstall
	self detach.
! !

!VictoryConditionDetector methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 19:12'!
victoryCondition
	^ victoryCondition! !

!VictoryConditionDetector methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 19:12'!
victoryCondition: anObject
	victoryCondition := anObject! !

Object subclass: #Match
	instanceVariableNames: 'rules result board victoryConditions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!Match commentStamp: 'SergioFedi 4/21/2016 08:22' prior: 0!
I model a match of a game.

You can see how to use me in ModelUsageExamples
!

Match subclass: #MECCGMatch
	instanceVariableNames: 'player1 player2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MECCGMatch commentStamp: 'SergioFedi 5/21/2016 20:22' prior: 0!
I model a match of a Middle Earth Collectible Card Game.

You can see how to use me in ModelUsageExamples
!

!MECCGMatch methodsFor: 'initialization' stamp: 'SergioFedi 5/21/2016 20:53'!
initialize

	super initialize.
	self board: MECCGBoard new.
	self rules: MiddleEarthCardGame rules.
! !

!MECCGMatch methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:54'!
player1

	^player1.! !

!MECCGMatch methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:59'!
player1: aMECCGPlayer
	self prepareForMatch: aMECCGPlayer.
	player1 := aMECCGPlayer! !

!MECCGMatch methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:54'!
player2

	^player2.! !

!MECCGMatch methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:58'!
player2: aMECCGPlayer
	self prepareForMatch: aMECCGPlayer.
	player2 := aMECCGPlayer! !

!MECCGMatch methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:56'!
players

	| players |
	players := OrderedCollection new.
	self player1 ifNotNil: [:player | players add: self player1].
	self player2 ifNotNil: [:player | players add: self player2].
	^players.! !

Match subclass: #MTGSMatch
	instanceVariableNames: 'player enemy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSMatch commentStamp: 'SergioFedi 5/8/2016 19:17' prior: 0!
I model a match of Magic The Gathering Solitaire Game.

!

!MTGSMatch class methodsFor: 'instance creation' stamp: 'SergioFedi 5/21/2016 23:06'!
of: aMagicSolitaireCardGameRules

	^self new rules: aMagicSolitaireCardGameRules.! !

!MTGSMatch methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 19:30'!
enemy
	^ enemy! !

!MTGSMatch methodsFor: 'public' stamp: 'SergioFedi 5/14/2016 20:09'!
enemy: aMTGSPlayer
 
	self prepareForMatch: aMTGSPlayer.
	enemy := aMTGSPlayer.! !

!MTGSMatch methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:36'!
player

	^player.! !

!MTGSMatch methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 22:36'!
player: aMTGSPlayer

	self prepareForMatch: aMTGSPlayer.
	player := aMTGSPlayer! !

!MTGSMatch methodsFor: 'public' stamp: 'SergioFedi 5/11/2016 16:55'!
players

	| definedPlayers |
	definedPlayers := OrderedCollection new: 2.
	self player ifNotNil: [ :player | definedPlayers add: player ].
	self enemy ifNotNil: [ :opponent | definedPlayers add: opponent  ].
	^definedPlayers.! !

!Match methodsFor: 'public' stamp: 'FedericoFigueredo 5/17/2016 09:03'!
addVictoryCondition: aVictoryCondition

	aVictoryCondition match: self.
	victoryConditions add: aVictoryCondition.! !

!Match methodsFor: 'public' stamp: 'FedericoFigueredo 5/5/2016 08:53'!
beginPhase: phase ofPlayer: aPlayerOfMECCG 
	self triggerEvent: #somethingHappened with: 'Begin phase named ', phase name, ' of player ', aPlayerOfMECCG name.! !

!Match methodsFor: 'public' stamp: 'FedericoFigueredo 5/5/2016 08:49'!
beginTurnOf: aPlayerOfMECCG 
	self triggerEvent: #somethingHappened with: 'Begin turn of player ', aPlayerOfMECCG name.! !

!Match methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 14:54'!
board
	^ board! !

!Match methodsFor: 'private' stamp: 'SergioFedi 5/8/2016 14:54'!
board: aGameBoard
	board := aGameBoard! !

!Match methodsFor: 'public' stamp: 'FedericoFigueredo 5/5/2016 08:55'!
endPhase: phase ofPlayer: aPlayerOfMECCG 
	self triggerEvent: #somethingHappened with: 'End of phase named ', phase name, ' of player ', aPlayerOfMECCG name.! !

!Match methodsFor: 'public' stamp: 'SergioFedi 5/19/2016 09:08'!
endTurnOf: aPlayerOfMECCG

	self result incrementTurnsPlayedBy: aPlayerOfMECCG.
	self triggerEvent: #somethingHappened with: 'End turn of player ', aPlayerOfMECCG name.! !

!Match methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:20'!
initialize
	super initialize.
	victoryConditions  := OrderedCollection new.! !

!Match methodsFor: 'private' stamp: 'SergioFedi 5/19/2016 09:05'!
initializeTurnsPlayedByPlayers

	self players do: [  :player |
		self result setAmountOfTurnsPlayedBy: player to: 0.
	]
! !

!Match methodsFor: 'public' stamp: 'FedericoFigueredo 5/17/2016 09:06'!
installVictoryConditionsDetectors
	self victoryConditions do: [ :victoryCondition | 
		victoryCondition installDetector.
	].
! !

!Match methodsFor: 'public' stamp: 'FedericoFigueredo 5/10/2016 09:04'!
isReadyForPlay

	^self rules isMatchReady: self.! !

!Match methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 16:50'!
isReadyForSetup
	self rules ifNil: [ ^false ].
	^ self rules isMatchReadyForSetup: self! !

!Match methodsFor: 'public' stamp: 'SergioFedi 4/28/2016 22:38'!
play

	self triggerEvent: #somethingHappened with: 'Match started'.
	self rules play: self.
! !

!Match methodsFor: 'public' stamp: 'FedericoFigueredo 5/5/2016 09:13'!
player: aPlayerOfMECCG played: anAction

	self triggerEvent: #somethingHappened with: 'Action ', anAction name, ' played by player ', aPlayerOfMECCG name.! !

!Match methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:21'!
players
	^ self subclassResponsibility.! !

!Match methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 20:59'!
prepareForMatch: aPlayer
	aPlayer match: self! !

!Match methodsFor: 'public' stamp: 'SergioFedi 4/17/2016 17:40'!
result

	^result.! !

!Match methodsFor: 'private' stamp: 'SergioFedi 4/17/2016 17:49'!
result: aMatchResult

	result := aMatchResult.! !

!Match methodsFor: 'public' stamp: 'SergioFedi 4/17/2016 17:13'!
rules
	^ rules! !

!Match methodsFor: 'private' stamp: 'SergioFedi 4/17/2016 17:13'!
rules: anObject
	rules := anObject! !

!Match methodsFor: 'public' stamp: 'SergioFedi 5/19/2016 09:03'!
setup
	self isReadyForSetup
		ifTrue: [
			self rules setupMatch: self.
			self initializeTurnsPlayedByPlayers.
		]! !

!Match methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 18:31'!
uninstallVictoryConditionsDetectors
	self victoryConditions do: [ :victoryCondition | 
		victoryCondition uninstallDetector.
	].
! !

!Match methodsFor: 'public' stamp: 'FedericoFigueredo 5/17/2016 08:15'!
victoryConditions
	^ victoryConditions.! !

!Match methodsFor: 'public' stamp: 'SergioFedi 4/17/2016 17:57'!
wrapUp

	self rules wrapUpMatch: self.! !

Object subclass: #MatchOutcome
	instanceVariableNames: 'matchStatistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MatchOutcome commentStamp: 'SergioFedi 4/21/2016 08:27' prior: 0!
I model the outcome of a match.

The particular data I will contain will be determined by the rules of the match.
!

!MatchOutcome methodsFor: 'public' stamp: 'SergioFedi 5/19/2016 08:57'!
amountOfPlayersTurns
	^ matchStatistics at: 'amountOfPlayersTurns'.! !

!MatchOutcome methodsFor: 'private' stamp: 'SergioFedi 5/19/2016 08:57'!
amountOfPlayersTurns: aDictionary 
	matchStatistics at: 'amountOfPlayersTurns' put: aDictionary.! !

!MatchOutcome methodsFor: 'public' stamp: 'SergioFedi 5/19/2016 09:09'!
incrementTurnsPlayedBy: aMECCGPlayer

	self amountOfPlayersTurns at: aMECCGPlayer put: (self amountOfPlayersTurns at: aMECCGPlayer) + 1.! !

!MatchOutcome methodsFor: 'as yet unclassified' stamp: 'SergioFedi 5/19/2016 08:56'!
initialize
	super initialize.
	matchStatistics := Dictionary new.
	self roundsFullyPlayed: nil.
	self isFinished: false.
	self winners: OrderedCollection new.
	self amountOfPlayersTurns: Dictionary new.! !

!MatchOutcome methodsFor: 'accesing' stamp: 'SergioFedi 4/22/2016 08:58'!
isFinished

	^matchStatistics at: 'isFinished'.! !

!MatchOutcome methodsFor: 'public' stamp: 'SergioFedi 4/22/2016 08:58'!
isFinished: anObject 

	matchStatistics at: 'isFinished' put: anObject.! !

!MatchOutcome methodsFor: 'accesing' stamp: 'FedericoFigueredo 5/3/2016 08:31'!
roundsFullyPlayed

	^matchStatistics at: #roundsFullyPlayed.! !

!MatchOutcome methodsFor: 'public' stamp: 'FedericoFigueredo 5/3/2016 08:46'!
roundsFullyPlayed: anObject 

	matchStatistics at: #roundsFullyPlayed put: anObject.! !

!MatchOutcome methodsFor: 'public' stamp: 'SergioFedi 5/19/2016 09:06'!
setAmountOfTurnsPlayedBy: aMECCGPlayer to: anInteger

	self amountOfPlayersTurns at: aMECCGPlayer put: anInteger.! !

!MatchOutcome methodsFor: 'public' stamp: 'SergioFedi 5/19/2016 08:56'!
turnsPlayedBy: aMECCGPlayer

	^self amountOfPlayersTurns at: aMECCGPlayer.! !

!MatchOutcome methodsFor: 'public' stamp: 'FedericoFigueredo 5/13/2016 08:47'!
winners
	^ matchStatistics at: 'winners'.! !

!MatchOutcome methodsFor: 'private' stamp: 'FedericoFigueredo 5/13/2016 08:46'!
winners: aCollection 
	matchStatistics at: 'winners' put: aCollection.! !

Object subclass: #Pile
	instanceVariableNames: 'cards'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!Pile commentStamp: 'SergioFedi 5/21/2016 22:33' prior: 0!
I model a pile of cards.!

!Pile methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:11'!
addCard: aCard

	self cards add: aCard.! !

!Pile methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:12'!
addCards: aCollection

	aCollection do: [ :card |
		self addCard: card.
	].! !

!Pile methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:09'!
cards
	^ cards! !

!Pile methodsFor: 'initialization' stamp: 'SergioFedi 5/22/2016 12:10'!
initialize

	super initialize.
	cards := OrderedCollection new.! !

!Pile methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:09'!
isEmpty

	^self cards isEmpty.! !

!Pile methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:12'!
notEmpty

	^self isEmpty not.! !

!Pile methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 12:11'!
size

	^self cards size.! !

Object subclass: #Player
	instanceVariableNames: 'name match'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!Player commentStamp: 'SergioFedi 4/21/2016 08:30' prior: 0!
I model a participant of a Match that plays in it.
!

Player subclass: #MECCGPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MECCGPlayer commentStamp: 'SergioFedi 4/25/2016 08:36' prior: 0!
I model a participant of a Match of MiddleEarthCardGame that plays in it.!

!MECCGPlayer methodsFor: 'public' stamp: 'SergioFedi 4/26/2016 09:09'!
chooseActionAmong: aCollection

	^aCollection atRandom.! !

Player subclass: #MTGSPlayer
	instanceVariableNames: 'hitPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSPlayer commentStamp: 'SergioFedi 5/8/2016 19:27' prior: 0!
I model a participant of a Match of MagicTheGatheringSolitareGame that plays in it.!

MTGSPlayer subclass: #MTGSHumanPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSHumanPlayer commentStamp: 'SergioFedi 5/8/2016 19:10' prior: 0!
I model a human player that plays a game of Magic The Gathering Solitaire.

Whenever the game needs something to be done by the player, I ask him what to do through an interface.!

!MTGSHumanPlayer methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 19:52'!
chooseActionAmong: aCollection

	^aCollection atRandom.
	
	"^MenuMorph
		chooseFrom: (aCollection collect: [:each | each printString])
		values: aCollection
		lines: #()
		title: 'Choose your action'."! !

!MTGSPlayer methodsFor: 'public' stamp: 'SergioFedi 5/14/2016 20:10'!
chooseActionAmong: aCollection

	^aCollection atRandom.! !

!MTGSPlayer methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 19:27'!
hitPoints

	^hitPoints.! !

!MTGSPlayer methodsFor: 'initialization' stamp: 'SergioFedi 5/8/2016 19:30'!
initialize

	super initialize.

	hitPoints := 20.! !

!MTGSPlayer methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:51'!
reduceHitpointsBy: anInteger

	hitPoints := hitPoints - anInteger.! !

!Player class methodsFor: 'instance creation' stamp: 'SergioFedi 4/17/2016 17:16'!
named: aString

	^self new name: aString.! !

!Player methodsFor: 'public' stamp: 'SergioFedi 4/25/2016 08:30'!
match
	^ match! !

!Player methodsFor: 'public' stamp: 'SergioFedi 4/25/2016 08:30'!
match: anObject
	match := anObject! !

!Player methodsFor: 'public' stamp: 'SergioFedi 4/17/2016 17:15'!
name
	^ name! !

!Player methodsFor: 'public' stamp: 'SergioFedi 4/17/2016 17:15'!
name: anObject
	name := anObject! !

Object subclass: #StringOfObjects
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Support'!

!StringOfObjects commentStamp: 'SergioFedi 5/2/2016 11:10' prior: 0!
I generalize the concept of String.

From String of Characters to a String of Objects.

For the moment my purpose is to solve the pattern matching problem for the more general case of matching a pattern of objects instead of a pattern of characters.
!

!StringOfObjects class methodsFor: 'public' stamp: 'SergioFedi 5/5/2016 07:18'!
withAll: aCollection

	^(self new)
		addAll: aCollection;
		yourself.! !

!StringOfObjects methodsFor: 'public' stamp: 'SergioFedi 5/2/2016 11:26'!
add: anObject
 
	objects add: anObject.! !

!StringOfObjects methodsFor: 'public' stamp: 'SergioFedi 5/5/2016 07:17'!
addAll: aCollection

	aCollection do: [:each |
		self add: each.
	].! !

!StringOfObjects methodsFor: 'private' stamp: 'SergioFedi 5/2/2016 13:51'!
alphabetFor: aCollection

	^(1 to: aCollection size) collect: [ :n | Character value: 64 + n ].! !

!StringOfObjects methodsFor: 'public' stamp: 'FedericoFigueredo 5/8/2016 13:44'!
areTheseStringsOrdered: aCollection allowingZeroOrMoreInstancesOf: aString

	| areOrdered logString regularExpresion |
	logString := self logAsStringFor: aCollection.
	regularExpresion := self regExpForAreTheseCharactersOrdered: aCollection allowingZeroOrMoreInstancesOf: aString.
	areOrdered := logString matchesRegex: regularExpresion.
	^areOrdered.! !

!StringOfObjects methodsFor: 'private' stamp: 'SergioFedi 5/2/2016 11:26'!
initialize

	super initialize.
	objects := OrderedCollection new.! !

!StringOfObjects methodsFor: 'public' stamp: 'SergioFedi 5/7/2016 14:40'!
isEmpty

	^objects isEmpty.! !

!StringOfObjects methodsFor: 'public' stamp: 'SergioFedi 5/6/2016 14:04'!
isSubstringOfInfiniteLoopGeneratedBy: aCollection
	"Answers true if aCollection of objects appear in order within the receiver.
	The presence of the objects is optional, but if they appear, they must be in the stated order."

	| areOrdered logString regularExpresion |
	aCollection isEmpty ifTrue: [ ^true ].
	logString := self logAsStringFor: aCollection.
	regularExpresion := self objectsAppearInOrderRegExpFor: aCollection.
	areOrdered := logString matchesRegex: regularExpresion.
	^areOrdered.! !

!StringOfObjects methodsFor: 'private' stamp: 'SergioFedi 5/6/2016 14:06'!
logAsStringFor: aCollection
	"Converts objects into a string consisting only of the interesting objects (aCollection)"

	| map string |
	string := WriteStream on: String new.
	map := Dictionary new.
	(self alphabetFor: aCollection) with: aCollection do: [ :character :object |
		map at: object put: character.
	].
	objects do: [ :object |
		| matchingObject |
		matchingObject := aCollection detect: [:obj | object asString beginsWith: obj asString] ifNone: [nil].
		(map includesKey: matchingObject) ifTrue: [ 
			string nextPut: (map at: matchingObject).
		].
	].
	^string contents.
	! !

!StringOfObjects methodsFor: 'private' stamp: 'SergioFedi 5/6/2016 12:26'!
objectsAppearInOrderRegExpFor: aCollection
	"ABCD -> (ABCD)*(A(B(C(D)?)?)?)?"

	| regExp codes |
	codes := self alphabetFor: aCollection.
	regExp := WriteStream on: String new.
	regExp nextPut: $(.
	regExp nextPutAll: codes.
	regExp nextPut: $).
	regExp nextPut: $*.
	codes do: [ :code |
		regExp nextPut: $(.
		regExp nextPut: code.
	].
	codes size timesRepeat: [ regExp nextPutAll: ')?' ].

	^regExp contents.
	! !

!StringOfObjects methodsFor: 'private' stamp: 'FedericoFigueredo 5/8/2016 13:47'!
regExpForAreTheseCharactersOrdered: aString allowingZeroOrMoreInstancesOf: aCharacter

	| regExp |
	self assert: aString size = 4.
	self assert: aString second = aCharacter.
	regExp := '(AB*CD)+'.
	^regExp.
	
! !

!StringOfObjects methodsFor: 'public' stamp: 'SergioFedi 5/2/2016 11:36'!
size

	^objects size.! !

Object subclass: #TurnPhase
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!TurnPhase commentStamp: 'SergioFedi 5/8/2016 21:32' prior: 0!
I model a phase of a turn.
A Phase of a Turn is a segment of a turn in which certain aspects of the game are resolved.

Examples:
	The beginning of the turn of a player is usually a phase of that player's turn.
	The section of a player's turn where he take the main actions is usually the Main Phase.
	
Of course all of this depends on the particular game.
!

TurnPhase subclass: #MECCGPhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MECCGPhase commentStamp: 'SergioFedi 4/26/2016 08:56' prior: 0!
I model a phase of a turn of the Middle Earth Collectible Card Game.
!

MECCGPhase subclass: #EndOfTurnPhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!EndOfTurnPhase commentStamp: 'SergioFedi 5/7/2016 11:12' prior: 0!
I model the end of turn phase of a turn of the Middle Earth Collectible Card Game.

For now, I check if the match has finished.!

!EndOfTurnPhase methodsFor: 'public' stamp: 'FedericoFigueredo 5/6/2016 09:06'!
endIn: aMatch
	(aMatch result roundsFullyPlayed >= 3) ifTrue: [ 
		aMatch result isFinished: true.
	]! !

!MECCGPhase methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:52'!
availableActionsForPlayer: aPlayerOfMECCG

	^Array
		with: MatchAction new 
		with: EndPhaseAction new.! !

TurnPhase subclass: #MTGSPhase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSPhase commentStamp: 'SergioFedi 5/20/2016 12:13' prior: 0!
I model a phase of a turn of the Magic The Gathering Solitaire Game.
I calculate the available actions that are for a player during the phase I model and perform any tasks that should be done during me.!

MTGSPhase subclass: #MTGSDrawPhase
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSDrawPhase commentStamp: 'SergioFedi 5/20/2016 12:12' prior: 0!
I model the draw phase of a turn of the Magic The Gathering Solitaire Game.
!

!MTGSDrawPhase methodsFor: 'private' stamp: 'SergioFedi 5/22/2016 00:48'!
actions

	^actions.! !

!MTGSDrawPhase methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:15'!
availableActionsForPlayer: aMTGSPlayer

	self actions do: [ :each | each actor: aMTGSPlayer ].
	^OrderedCollection with: self actions last.! !

!MTGSDrawPhase methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:48'!
handleSuccessOfAction: aMTGSDrawCardAction

	self actions remove: aMTGSDrawCardAction.! !

!MTGSDrawPhase methodsFor: 'initialization' stamp: 'SergioFedi 5/22/2016 01:19'!
initialize

	super initialize.
	self name: 'Draw'.
	actions := OrderedCollection
		with: EndPhaseAction new
		with: (MTGSDrawCardAction phase: self).
! !

!MTGSDrawPhase methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 01:32'!
remainingDraws

	^(actions select: [:each | each endsPhase not]) size.! !

!MTGSPhase methodsFor: 'public' stamp: 'SergioFedi 5/15/2016 19:11'!
availableActionsForPlayer: aMECCGPlayer

	^OrderedCollection
		with: (MTGSAttackAction match: aMECCGPlayer match) 
		with: EndPhaseAction new.! !

!TurnPhase class methodsFor: 'instance creation' stamp: 'SergioFedi 5/8/2016 21:50'!
named: aString

	^self new name: aString.! !

!TurnPhase methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:45'!
availableActionsForPlayer: aPlayerOfMECCG

	self subclassResponsibility.! !

!TurnPhase methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:33'!
beginIn: aMatch
	! !

!TurnPhase methodsFor: 'public' stamp: 'SergioFedi 5/8/2016 21:33'!
endIn: aMatch
	! !

!TurnPhase methodsFor: 'accessing' stamp: 'SergioFedi 5/8/2016 21:32'!
name
	^ name! !

!TurnPhase methodsFor: 'accessing' stamp: 'SergioFedi 5/8/2016 21:33'!
name: aString
	name := aString! !

Object subclass: #Validator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!Validator commentStamp: 'SergioFedi 5/11/2016 08:20' prior: 0!
Objects of this class determine whether other objects are valid or not.

As such, they are allowed to call private methods.
!

Validator subclass: #GameBoardValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!GameBoardValidator commentStamp: 'SergioFedi 5/15/2016 18:57' prior: 0!
Validates the structure of a game board.!

!GameBoardValidator methodsFor: 'public' stamp: 'SergioFedi 5/15/2016 18:56'!
isThereAZoneForEachPlayerIn: aGameBoard 
	^ aGameBoard zones size = 2.! !

GameBoardValidator subclass: #MECCGBoardValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!MECCGBoardValidator commentStamp: 'SergioFedi 5/11/2016 08:20' prior: 0!
Validates the structure of a Board of Middle Earth Collectible Card Game for two players.!

!MECCGBoardValidator methodsFor: 'public' stamp: 'SergioFedi 5/14/2016 19:32'!
arePilesValidIn: aBoardZone

	aBoardZone playPile isNil ifTrue: [ ^false ].
	aBoardZone discardPile isNil ifTrue: [ ^false ].
	aBoardZone outOfPlayPile isNil ifTrue: [ ^false ].
	aBoardZone marshallingPile isNil ifTrue: [ ^false ].
	^true.! !

!MECCGBoardValidator methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:27'!
isPlayerHandValidIn: aBoardZone

	(aBoardZone hand isNil) ifTrue: [^false].
	^true.! !

!MECCGBoardValidator methodsFor: 'public' stamp: 'FedericoFigueredo 5/10/2016 08:48'!
isValid: aMECCGBoard
	^ true.! !

GameBoardValidator subclass: #MTGSBoardValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-MTGS'!

!MTGSBoardValidator commentStamp: 'SergioFedi 5/15/2016 18:58' prior: 0!
Validates the structure of a Board of Magic The Gathering Solitaire Game of two players.!

!MTGSBoardValidator methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:42'!
arePilesValidIn: aBoardZone

	aBoardZone libraryPile isNil ifTrue: [ ^false ].
	^true.! !

!MTGSBoardValidator methodsFor: 'public' stamp: 'SergioFedi 5/22/2016 10:27'!
isPlayerHandValidIn: aMTGSBoardZone

	(aMTGSBoardZone hand isNil) ifTrue: [^false].
	^true.
	! !

!MTGSBoardValidator methodsFor: 'public' stamp: 'SergioFedi 5/15/2016 18:57'!
isValid: aMECCGBoard
	^ true.! !

Object subclass: #VictoryCondition
	instanceVariableNames: 'name match detector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

VictoryCondition subclass: #TurnsPlayedVictoryCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MECCG-Model'!

!TurnsPlayedVictoryCondition methodsFor: 'private' stamp: 'FedericoFigueredo 5/20/2016 09:02'!
defaultThreshold
	^ 121.! !

!TurnsPlayedVictoryCondition methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 18:43'!
newDetector

	^ TurnsPlayedVictoryConditionDetector on: match.! !

!TurnsPlayedVictoryCondition methodsFor: 'private' stamp: 'SergioFedi 5/19/2016 09:21'!
turnsPlayed

	^self match players
		inject: 0
		into: [ :subtotal :player |
			subtotal + (self match result turnsPlayedBy: player)
		]! !

!TurnsPlayedVictoryCondition methodsFor: 'public' stamp: 'FedericoFigueredo 5/20/2016 09:02'!
turnsThreshold
	^ self defaultThreshold.! !

!VictoryCondition class methodsFor: 'instance creation' stamp: 'FedericoFigueredo 5/17/2016 08:47'!
named: aString 
	^ self new name: aString.! !

!VictoryCondition methodsFor: 'public' stamp: 'SergioFedi 5/18/2016 09:41'!
detector

	^detector.! !

!VictoryCondition methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:13'!
installDetector

	detector := self newDetector.
	detector victoryCondition: self.
	detector install.! !

!VictoryCondition methodsFor: 'public' stamp: 'FedericoFigueredo 5/17/2016 09:16'!
match
	^ match.! !

!VictoryCondition methodsFor: 'private' stamp: 'FedericoFigueredo 5/17/2016 09:04'!
match: aMatch

	match := aMatch.! !

!VictoryCondition methodsFor: 'public' stamp: 'FedericoFigueredo 5/17/2016 08:21'!
name
	^ name! !

!VictoryCondition methodsFor: 'private' stamp: 'FedericoFigueredo 5/17/2016 08:21'!
name: anObject
	name := anObject! !

!VictoryCondition methodsFor: 'private' stamp: 'SergioFedi 5/21/2016 18:43'!
newDetector

	^ self subclassResponsibility.! !

!VictoryCondition methodsFor: 'public' stamp: 'SergioFedi 5/21/2016 19:03'!
uninstallDetector
	
	detector uninstall.
	detector := nil.
! !
